package javax.swing.text;

import javax.swing.event.UndoableEditListener;
import javax.swing.event.DocumentListener;

public interface Document
{
    public static final String StreamDescriptionProperty = "stream";
    public static final String TitleProperty = "title";
    
    public abstract int getLength();
    
    public abstract void addDocumentListener(DocumentListener p0);
    
    public abstract void removeDocumentListener(DocumentListener p0);
    
    public abstract void addUndoableEditListener(UndoableEditListener p0);
    
    public abstract void removeUndoableEditListener(UndoableEditListener p0);
    
    public abstract Object getProperty(Object p0);
    
    public abstract void putProperty(Object p0, Object p1);
    
    public abstract void remove(int p0, int p1) throws BadLocationException;
    
    public abstract void insertString(int p0, String p1, AttributeSet p2) throws BadLocationException;
    
    public abstract String getText(int p0, int p1) throws BadLocationException;
    
    public abstract void getText(int p0, int p1, Segment p2) throws BadLocationException;
    
    public abstract Position getStartPosition();
    
    public abstract Position getEndPosition();
    
    public abstract Position createPosition(int p0) throws BadLocationException;
    
    public abstract Element[] getRootElements();
    
    public abstract Element getDefaultRootElement();
    
    public abstract void render(Runnable p0);
}
